return (function ()
  local make=function ()
    local pal={}
    for p=0,31 do
      pal[p]={{15,0,15},{0,0,15},{15,15,15}}
      pal[p][0]={0,0,15}
      pal[p][0][0]=0
      pal[p][1][0]=0
      pal[p][2][0]=15
      pal[p][3][0]=15
    end
    local data=love.image.newImageData(32,4)
    local image=love.graphics.newImage(data)
    image:setWrap("repeat","repeat")
    image:setFilter("nearest","nearest")    
    return {getColor=function(p,c)
      return pal[p][c]
    end, getImage=function()
      local ptr=ffi.cast('unsigned char*',data:getPointer())
      for c=0,3 do 
        for p=0,31 do
          local f=pal[p][c]
          for x=0,3 do
            ptr[0]=f[x]*17
            ptr=ptr+1
          end
        end
      end
      image:refresh()
      return image                      
    end}
  end
  return {new=make}
end)()
