return (function ()
  local make=function ()
    local tiles={}
    for i=0,255 do
      tiles[i]={}
      for y=0,15 do
        tiles[i][y]={}
        for x=0,15 do
          tiles[i][y][x]=0
        end
      end
    end
    local data=love.image.newImageData(256,256)
    local image=love.graphics.newImage(data)
    image:setWrap("repeat","repeat")
    image:setFilter("nearest","nearest")    
    return {getTile=function(i)
      return tiles[i]      
    end, getImage=function()
      local ptr=ffi.cast('unsigned char*',data:getPointer())
      for ty=0,15 do
        for y=0,15 do
          for tx=0,15 do 
            for x=0,15 do
              ptr[0]=tiles[tx+ty*16][y][x]*64
              ptr=ptr+4
            end
          end
        end
      end
      image:refresh()
      return image                
    end, copyTile=function(o,n)
      o,n=tiles[o],tiles[n]
      for y=0,15 do
        for x=0,15 do
          n[y][x]=o[y][x]
        end
      end      
    end}
  end
  return {new=make}
end)()
